Name: pvm
Summary: Parallel Virtual Machine
Version: 3.4.5
Release: 3tr
Group : Trustix Official
License: Freely Distributable
Source0: http://www.netlib.org/pvm3/%{name}%{version}.tgz
Source1: pvmd.init
Source2: pvm.sh
Patch0 : pvm-3.4.5-rsh.patch
Prereq: chkconfig, tsl-utils
URL: http://www.csm.ornl.gov/pvm/pvm_home.html
BuildRoot : %{_tmppath}/%{name}-%{version}-root

%define _pvm_root %{_libdir}/pvm3
%define _pvm_arch LINUX

%description
PVM (Parallel Virtual Machine) is a software system that enables a collection of
heterogeneous computers to be used as a coherent and flexible concurrent
computational resource. The individual computers may be shared- or local-memory
multiprocessors, vector supercomputers, specialized graphics engines, or scalar
workstations, that may be interconnected by a variety of networks, such as
ethernet, FDDI, etc. PVM support software executes on each machine in a
user-configurable pool, and presents a unified, general, and powerful
computational environment of concurrent applications. 

%package devel
Summary: PVM header files and static libraries 
Group : Trustix Official
Requires : %{name} = %{version}-%{release}

%description devel
This package contains PVM header files and static libraries.

%package docs
Summary: PVM examples
Group: Trusitx Official
Requires: %{name} = %{version}-%{release}

%description docs
This package contains PVM examples written in C and Fortran, and book
written in English.

%prep
%setup -q -n %{name}3
%patch0 -p1

%build 
cp -f lib/aimk lib/aimk.tmp
sed -e "s!@PVM_ROOT@!%{_pvm_root}!" -e "s!@PVM_ARCH@!%{_pvm_arch}!" lib/aimk.tmp > lib/aimk
CFLOPTS="-DDEFBINDIR=\\\"%{_pvm_root}/lib/%{_pvm_arch}\\\" \
         -DDEFDEBUGGER=\\\"%{_pvm_root}/lib/debugger2\\\" \
         -DPVMDPATH=\\\"%{_pvm_root}/lib/%{_pvm_arch}/pvmd3\\\" \
         -DPVMROOT=\\\"%{_pvm_root}\\\""

export PVM_ROOT=`pwd`
make 

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"
mkdir -p $RPM_BUILD_ROOT%{_pvm_root}/{lib,bin}/%{_pvm_arch}
mkdir -p $RPM_BUILD_ROOT/var/run/pvm3
                                                                                                                             
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir},%{_libdir},%{_pvm_root}/conf} \
           $RPM_BUILD_ROOT{%{_mandir}/man{1,3},/etc/init.d,%{_sbindir}}

install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/pvmd
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/pvm
install -m 755 lib/%{_pvm_arch}/{pvm,pvmgs} $RPM_BUILD_ROOT%{_pvm_root}/lib/%{_pvm_arch}
install -m 755 lib/%{_pvm_arch}/pvmd3 $RPM_BUILD_ROOT%{_pvm_root}/lib/%{_pvm_arch}
install -m 755 lib/pvm  $RPM_BUILD_ROOT%{_pvm_root}
install -m 755 lib/pvmd $RPM_BUILD_ROOT%{_pvm_root}/lib
install -m 755 lib/debugger*  $RPM_BUILD_ROOT%{_pvm_root}/lib
install -m 755 lib/pvm*arch   $RPM_BUILD_ROOT%{_pvm_root}/lib
install -m 755 lib/aimk       $RPM_BUILD_ROOT%{_pvm_root}/lib
install -m 644 conf/%{_pvm_arch}.def $RPM_BUILD_ROOT%{_pvm_root}/conf
install -m 644 include/*.h $RPM_BUILD_ROOT%{_includedir}
install -m 755 lib/%{_pvm_arch}/lib*.a $RPM_BUILD_ROOT%{_pvm_root}/lib/%{_pvm_arch}
install -m 755 man/man1/* $RPM_BUILD_ROOT%{_mandir}/man1
install -m 644 man/man3/* $RPM_BUILD_ROOT%{_mandir}/man3

for i in "examples gexamples hoster misc tasker xep"
do
     cp -R $i  $RPM_BUILD_ROOT%{_pvm_root}
done

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"

%post
/sbin/chkconfig --add pvmd
if [ $1 = 2 ]; then
   /sbin/restart_maybe pvmd
fi

%preun
if [ $1 = 0 ]; then
   if [ -f /var/run/pvm3/pvmd.? ]; then
       %{_initdir}/pvmd stop
   fi
   /sbin/chkconfig --del pvmd
fi

%files
%defattr(-,root,root)
%dir %{_pvm_root}/bin/%{_pvm_arch}
%{_mandir}/man1/pvm*
%{_mandir}/man1/PVM*
%{_sysconfdir}/init.d/pvmd
%{_bindir}/pvm
%{_pvm_root}/lib/pvmd
%{_pvm_root}/lib/debugger
%{_pvm_root}/lib/debugger
%{_pvm_root}/lib/debugger2
%{_pvm_root}/lib/pvmgetarch
%{_pvm_root}/lib/pvmtmparch
%{_pvm_root}/pvm*
%{_pvm_root}/conf/%{_pvm_arch}.def
%{_pvm_root}/lib/%{_pvm_arch}/pvmd3
%{_pvm_root}/lib/%{_pvm_arch}/pvm
%{_pvm_root}/lib/%{_pvm_arch}/pvmgs
%dir %attr(775,root,root) /var/run/pvm3

%files devel
%defattr(-,root,root)
%{_includedir}/*.h
%{_pvm_root}/lib/aimk
%{_pvm_root}/lib/%{_pvm_arch}/lib*.a
%{_mandir}/man1/aimk.1*
%{_mandir}/man3/*

%files docs
%defattr(-,root,root)
%{_pvm_root}/examples
%{_pvm_root}/gexamples
%{_pvm_root}/hoster
%{_pvm_root}/misc
%{_pvm_root}/tasker
%{_pvm_root}/xep

%changelog
* Mon Feb 26 2007 Nived Gopalan <nived at trustix dot org>
- Rebuilt

* Thu Aug 10 2006 Nived Gopalan <nived at trustix dot org> 3.4.5-2tr
- Added PreReq chkconfig and tsl-utils.

* Mon Sep 12 2005 Bipin S <bipin at comodo dot com> 3.4.5-1tr
- Initial version for TSL-3.0
